var forecastArr;
var windowWidth, windowHeight;
var stage,canvas;

//textfields

var theme;

var dayTemp, city, condition, wind, humidity;
var daysArray;
var loader;
var assets = [];
var images = [];
var bgImage;
var backColor;
var mainURL;
var manifest = [
	//weather icons
	/*
	{src:'images/chancerain.png', id:'chancerain'},
	{src:'images/chancesnow.png', id:'chancesnow'},
	{src:'images/chancetstorms.png', id:'chancetstorms'},
	{src:'images/clear.png', id:'clear'},
	{src:'images/partlycloudy.png', id:'partlycloudy'}
	*/
];
var iconsOnStage = [];
var chanceRain,chanceSnow, chanceStorm, chanceClear, chanceCloudy; 
var objMain; //main JSON object

var sunY = 0;//lib.clowdy.sun.y;
//var sunX = lib.clowdy.sun.x;
//var norX = lib.clowdy.nor2.x;
var norY = 0//liv.clowdy.nor2.y;

var GRAVITY = 4;
var FRICTION = 0.8;

var iconScale = 0.35;

var rainArr = [];
var rainCount = 0;

var snowArr = [];
var snowCount = 0;

var weekday = new Array(7);
weekday[0] = 'Sun';
weekday[1] = 'Mon';
weekday[2] = 'Tue';
weekday[3] = 'Wed';
weekday[4] = 'Thu';
weekday[5] = 'Fri';
weekday[6] = 'Sat';

function setInLoadQueue(s)
{
	bgImage = s;
}

function setInColorQueue(s)
{
	backColor = s;
}

function setMainURL(s)
{
	mainURL = s;
}

function initWeather(u)
{
	objMain = u;
	//console.log('initing:',u)
	loader = new createjs.LoadQueue(false);
	loader.addEventListener('fileload', handleFileLoad);
	loader.addEventListener('complete', handleComplete);
	loader.addEventListener('progress', handleProgress);
	loader.loadManifest(manifest);
	//initIcons();
	continueInit(objMain);
}

function initIcons()
{
	chanceRain = new lib.rainy();
	chanceRain.scaleX = iconScale;
	chanceRain.scaleY = iconScale;
	chanceRain.x = 25;
	chanceRain.y = 25;

	chanceSnow = new lib.snowy();
	chanceSnow.scaleX = iconScale;
	chanceSnow.scaleY = iconScale;
	chanceSnow.x = 25;
	chanceSnow.y = 25;

	chanceStorm = new lib.stormy();
	chanceStorm.scaleX = iconScale;
	chanceStorm.scaleY = iconScale;
	chanceStorm.x = 25;
	chanceStorm.y = 25;


	chanceClear = new lib.sunn();
	chanceClear.scaleX = iconScale;
	chanceClear.scaleY = iconScale;
	chanceClear.x = 25;
	chanceClear.y = 25;

	chanceCloudy = new lib.clowdyz();
	chanceCloudy.scaleX = iconScale;
	chanceCloudy.scaleY = iconScale;
	chanceCloudy.x = 25;
	chanceCloudy.y = 25;

}

function loadImageAndFitTo(img, fitIn, w, h)
{
	var bitmap = new createjs.Bitmap(img);
	var originalW = bitmap.image.width;
	var originalH = bitmap.image.height;
	var desiredW = w;
	var desiredH = h;

	bitmap.scaleX = desiredW / originalW;
	bitmap.scaleY = desiredH / originalH;
	return bitmap;
}

function loadImageandPutTo(img, putIn, w, h)
{
	//console.log('loading image:'+img);
	var bitmap = new createjs.Bitmap(img);
	var originalW = bitmap.image.width;
	var originalH = bitmap.image.height;
	var desiredW = w;
	var desiredH = h;

	bitmap.scaleX = bitmap.scaleY = desiredW / originalW;
	return bitmap;

	//putIn.addChild(bitmap);
	/*
	image.onload = function(evt){
		var im = e.target;
		im.width = w;
		im.height = h;
		putIn.addChild(im);
	}
	image.src = img;
	*/	
}

function continueInit(o)
{
	//console.log('contiunuing init');
	windowWidth = window.innerWidth;
	windowHeight = window.innerHeight;
	canvas = document.getElementById('weatherContainer');
	stage = new createjs.Stage(canvas);
	stage.canvas.width = 1280;//windowWidth;
	stage.canvas.height = 900;//windowHeight;
	var context = canvas.getContext("2d");
 	context.imageSmoothingEnabled = true;
 	//var graphics = new createjs.Graphics().beginFill("#000000").drawRect(0, 0, windowWidth, 170);
 	//var bgShape = new createjs.Shape(graphics);
 	//bgShape.alpha = 0.2;
 	var bgCont = new createjs.Container();

 	if (backColor)
 	{
 		var shape = new createjs.Shape();
 		shape.graphics.beginFill(backColor).drawRect(0, 0, 1280, 900);
 		bgCont.addChild(shape);
 		//console.log('added bg color');
 		stage.addChild(bgCont);
 	}

 	if (bgImage && bgImage!='noImage') {
 		//bgCont.addChild(loadImageandPutTo('images/'+bgImage, bgCont, windowWidth, windowHeight));
 		bgCont.addChild(loadImageAndFitTo('images/'+bgImage, bgCont, 1280, 900));
 		//bgCont.width = windowWidth;
 		//bgCont.height = windowHeight;
		if (bgCont.stage == null) stage.addChild(bgCont);
 	}

 	/* add a qr code from google api
 	var qrCont = new createjs.Container();
 	var gqrurl = 'http://chart.googleapis.com/chart?cht=qr&chs=400x400&chl='+mainURL;
 	var qrSize = (windowHeight - 170) - (windowHeight-170)/5;
 	qrCont.addChild(loadImageandPutTo(gqrurl, qrCont, qrSize, qrSize));
 	qrCont.x = windowWidth/2 - qrSize/2;
 	qrCont.y = qrSize/10;
 	qrCont.compositeOperation = 'overlay';
 	qrCont.alpha = 0.6;
 	stage.addChild(qrCont);
	*/

	var textsContainer = new createjs.Container();
	//textsContainer.addChild(bgShape);
	stage.addChild(textsContainer);
	//console.log('theme:',theme)
	var dayy = new Date(o.forecast.time[0].day);
	switch (theme){
		case '4':
			var cityHolder = new lib.moredes41();
			cityHolder.scaleY = 2.1;
			cityHolder.scaleX = 1.9;
			cityHolder.y = 20;
			cityHolder.x = -5;
			stage.addChild(cityHolder);

			// EU city = new createjs.Text(o['yweather:location'].city+', '+o['yweather:location'].country, 'bold 32px Montserrat', '#FFFFFF');
			//US
			city = new createjs.Text(o.location.name+', '+o.location.country, 'bold 32px Montserrat', '#FFFFFF');
			city.y = 7;
			city.x = (680 - city.getBounds().width)/2;
			//console.log(city.getBounds().width);
			cityHolder.addChild(city);
			break;
		case '3':
			var cityHolder = new lib.moredes21();
			cityHolder.scaleY = 2;
			cityHolder.scaleX = 1.9;
			cityHolder.y = 20;
			cityHolder.x = -3;
			cityHolder.shape.alpha = 0.7

			city = new createjs.Text(o.location.name+', '+o.location.country+' - current conditions: ', 'bold 18px Montserrat', '#FFFFFF');
			city.y = 6;
			city.x = 15;//(680 - city.getBounds().width)/2;
			cityHolder.addChild(city);

			//console.log('forecast: ',o.item['yweather:forecast'][0].day)

			currentDay = new createjs.Text(getFullDay(dayy.getDay()), 'bold 18px Montserrat', '#FFFFFF');
			currentDay.y = 6;
			currentDay.x = 660;
			currentDay.textAlign = 'right';
			cityHolder.addChild(currentDay);

			var cityIcon = displayFromCode(o.forecast.time[0].symbol.number);
			cityIcon.x = 90;
			cityIcon.y = 30;
			cityIcon.scaleX = cityIcon.scaleY = 0.6;

			currentTemp = new createjs.Text(Math.round(o.forecast.time[0].temperature.day)+'°', 'bold 64px Montserrat', '#FFFFFF');
			currentTemp.y = 5;
			currentTemp.x = 320;
			currentTemp.textAlign = 'right';

			currentCond = new createjs.Text(o.forecast.time[0].clouds.value, 'bold 18px Montserrat', '#FFFFFF');
			currentCond.y = 70;
			currentCond.x = 260;
			currentCond.textAlign = 'center';

			var oneDayHolder = new lib.headerFrBg2();
			oneDayHolder.scaleX = 1.3;
			oneDayHolder.scaleY = 2;
			oneDayHolder.x = 400;
			oneDayHolder.y = 150;
			oneDayHolder.shape.alpha = 0.3;

			oneDayHolder.addChild(cityIcon);
			oneDayHolder.addChild(currentTemp);
			oneDayHolder.addChild(currentCond);

			stage.addChild(oneDayHolder);
			stage.addChild(cityHolder);
			break;
		case '2':
			var cityHolder = new lib.moredes11();
			cityHolder.scaleY = 2;
			cityHolder.scaleX = 1.9;
			cityHolder.y = 20;
			cityHolder.x = -3;
			cityHolder.shape.alpha = 0.4

			city = new createjs.Text(o.location.name+', '+o.location.country+' - current conditions: ', 'bold 18px Montserrat', '#FFFFFF');
			city.y = 5;
			city.x = 15;//(680 - city.getBounds().width)/2;
			cityHolder.addChild(city);

			//console.log('forecast: ',o.item['yweather:forecast'][0].day)

			currentDay = new createjs.Text(getFullDay(dayy.getDay()), 'bold 18px Montserrat', '#FFFFFF');
			currentDay.y = 5;
			currentDay.x = 660;
			currentDay.textAlign = 'right';
			cityHolder.addChild(currentDay);

			var cityIcon = displayFromCode(o.forecast.time[0].symbol.number);
			cityIcon.x = 90;
			cityIcon.y = 30;
			cityIcon.scaleX = cityIcon.scaleY = 0.6;

			currentTemp = new createjs.Text(Math.round(o.forecast.time[0].temperature.day)+'°', 'bold 64px Montserrat', '#FFFFFF');
			currentTemp.y = 5;
			currentTemp.x = 320;
			currentTemp.textAlign = 'right';

			currentCond = new createjs.Text(o.forecast.time[0].clouds.value, 'bold 18px Montserrat', '#FFFFFF');
			currentCond.y = 70;
			currentCond.x = 260;
			currentCond.textAlign = 'center';

			var oneDayHolder = new lib.headerFrBg2();
			oneDayHolder.scaleX = 1.3;
			oneDayHolder.scaleY = 2;
			oneDayHolder.x = 400;
			oneDayHolder.y = 150;
			oneDayHolder.shape.alpha = 0.3;

			oneDayHolder.addChild(cityIcon);
			oneDayHolder.addChild(currentTemp);
			oneDayHolder.addChild(currentCond);

			stage.addChild(oneDayHolder);
			stage.addChild(cityHolder);
			break;
		case '1':
			var cityHolder = new lib.moredes01();
			cityHolder.scaleY = 2;
			cityHolder.scaleX = 1.9;
			cityHolder.y = 20;
			cityHolder.x = -3;
			cityHolder.shape.alpha = 0.4

			city = new createjs.Text(o.location.name+', '+o.location.country+' - current conditions: ', 'bold 18px Montserrat', '#FFFFFF');
			city.y = 5;
			city.x = 15;//(680 - city.getBounds().width)/2;
			cityHolder.addChild(city);

			//console.log('forecast: ',o.item['yweather:forecast'][0].day)
			console.log('fullDay:', dayy.getDay());
			currentDay = new createjs.Text(getFullDay(dayy.getDay()), 'bold 18px Montserrat', '#FFFFFF');
			currentDay.y = 5;
			currentDay.x = 660;
			currentDay.textAlign = 'right';
			cityHolder.addChild(currentDay);

			var cityIcon = displayFromCode(o.forecast.time[0].symbol.number);
			cityIcon.x = 90;
			cityIcon.y = 30;
			cityIcon.scaleX = cityIcon.scaleY = 0.6;

			currentTemp = new createjs.Text(Math.round(o.forecast.time[0].temperature.day)+'°', 'bold 64px Montserrat', '#FFFFFF');
			currentTemp.y = 5;
			currentTemp.x = 320;
			currentTemp.textAlign = 'right';

			currentCond = new createjs.Text(o.forecast.time[0].clouds.value, 'bold 18px Montserrat', '#FFFFFF');
			currentCond.y = 70;
			currentCond.x = 260;
			currentCond.textAlign = 'center';

			var oneDayHolder = new lib.headerFrBg2();
			oneDayHolder.scaleX = 1.3;
			oneDayHolder.scaleY = 2;
			oneDayHolder.x = 400;
			oneDayHolder.y = 150;
			oneDayHolder.shape.alpha = 0.3;

			oneDayHolder.addChild(cityIcon);
			oneDayHolder.addChild(currentTemp);
			oneDayHolder.addChild(currentCond);

			stage.addChild(oneDayHolder);
			stage.addChild(cityHolder);
			break;
		
	}
/*
	dayTemp = new createjs.Text(o.item['yweather:condition'].temp+'°', 'bold 95px Arial', '#CCCCCC');
	dayTemp.x = 160;
	dayTemp.y = 71;
	dayTemp.textAlign = 'right';
	condition = new createjs.Text(o.item['yweather:condition'].text, '24px Arial', '#000000');
	condition.y = 75;
	condition.x = 170;
	var dir = degreesToDirection(o['yweather:wind'].direction)
	wind = new createjs.Text('Wind: '+o['yweather:wind'].speed+o['yweather:units'].distance+'/h '+dir, '20px Arial', "#000000");
	wind.y = 104;
	wind.x = 170;
	humidity = new createjs.Text('Humidity: '+o['yweather:atmosphere'].humidity+'%', '20px Arial', '#000000')
	humidity.y = 130;
	humidity.x = 170;
	
	textsContainer.addChild(dayTemp);
	textsContainer.addChild(condition);
	textsContainer.addChild(wind);
	textsContainer.addChild(humidity);
	//textsContainer.addChild(day1);
*/
	//console.log('forecast:',o.forecast);
	for (var i=0;i<o.forecast.time.length;i++)
	//for (var i=0;i<dDays;i++)

	{	
		var day;
		var dayDate = new Date(o.forecast.time[i].day);
		//console.log('theme:'+theme);
		switch (theme){
			case '4':
				//day = createDayWeather4(getFullDay(o.item['yweather:forecast'][i].day), o.item['yweather:forecast'][i].high, o.item['yweather:forecast'][i].low, o.item['yweather:forecast'][i].code, o.item['yweather:forecast'][i].text);
				//console.log('case 4');
				day = createDayWeather4(weekday[dayDate.getDay()], Math.round(o.forecast.time[i].temperature.max), Math.round(o.forecast.time[i].temperature.min), o.forecast.time[i].symbol.number, o.forecast.time[i].clouds.value);
				day.x = 150 + (200*i);
				day.y = 200;
				day.scaleX = 1.7;
				day.scaleY = 2;
				break;
			case '3':
				day = createDayWeather3(weekday[dayDate.getDay()], Math.round(o.forecast.time[i].temperature.max), Math.round(o.forecast.time[i].temperature.min), o.forecast.time[i].symbol.number, o.forecast.time[i].clouds.value);
				day.x = 20 + (254*i);
				day.y = 400;
				day.scaleX = 1.8;
				day.scaleY = 2.3;
				break;
			case '2':
				day = createDayWeather2(weekday[dayDate.getDay()], Math.round(o.forecast.time[i].temperature.max), Math.round(o.forecast.time[i].temperature.min), o.forecast.time[i].symbol.number, o.forecast.time[i].clouds.value);
				day.x = 20 + (254*i);
				day.y = 400;
				day.scaleX = 1.8;
				day.scaleY = 2.3;
				break;
			case '1':
				day = createDayWeather1(weekday[dayDate.getDay()], Math.round(o.forecast.time[i].temperature.max), Math.round(o.forecast.time[i].temperature.min), o.forecast.time[i].symbol.number, o.forecast.time[i].clouds.value);
				day.x = 20 + (254*i);
				day.y = 400;
				day.scaleX = 1.8;
				day.scaleY = 2.3;
				break;
		}
			
		textsContainer.addChild(day);
	}
	//textsContainer.y = windowHeight - 170;
	//console.log('canvas?'+canvas)
	//console.log('title: '+o.title);
	//console.log('forecast: '+o.item['yweather:forecast'][0].day+', temp:'+o.item['yweather:condition'].temp)
	//console.log('sw:'+windowWidth+', sh:'+windowHeight);
	//console.log('sc:'+stage.canvas.width+', '+stage.canvas.height)
	stage.update();

	createjs.Ticker.setFPS(12);
	createjs.Ticker.addEventListener('tick', tick);
}

function handleFileLoad(evt) {
	if (evt.item.type == "image") { images[evt.item.id] = evt.result; }
	assets.push(evt.item);
}

function handleProgress(evt)
{
	//progressbar here
}

function handleComplete(evt)
{
	//console.log('Assets loaded')
	for (var i=0; i<assets.length; i++)
	{
		var item = assets[i];
		var id = item.id;
		var result;
		if (id=='chancerain')
		{
			result = loader.getResult(id);
			chanceRain = new createjs.Shape(new createjs.Graphics().beginBitmapFill(result).drawRect(0, 0, 64, 64));
			chanceRain.regX = 32;
			chanceRain.regY = 32;
		}

		if (id=='chancesnow')
		{
			result = loader.getResult(id);
			chanceSnow = new createjs.Shape(new createjs.Graphics().beginBitmapFill(result).drawRect(0, 0, 64, 64));
			chanceSnow.regX = 32;
			chanceSnow.regY = 32;
		}

		if (id=='chancetstorms')
		{
			result = loader.getResult(id);
			chanceStorm = new createjs.Shape(new createjs.Graphics().beginBitmapFill(result).drawRect(0, 0, 64, 64));
			chanceStorm.regX = 32;
			chanceStorm.regY = 32;
		}
		if (id=='clear')
		{
			result = loader.getResult(id);
			chanceClear = new createjs.Shape(new createjs.Graphics().beginBitmapFill(result).drawRect(0, 0, 64, 64));
			chanceClear.regX = 32;
			chanceClear.regY = 32;
		}

		if (id=='partlycloudy')
		{
			result = loader.getResult(id);
			chanceCloudy = new createjs.Shape(new createjs.Graphics().beginBitmapFill(result).drawRect(0, 0, 64, 64));
			chanceCloudy.regX = 32;
			chanceCloudy.regY = 32;
		}
	}

	//continueInit(objMain);	--- debifeaza daca sunt imagini
}


function degreesToDirection(nr)

{

	if (nr >= 348.75 || nr < 11.25) return 'N';
	if (nr >= 11.25 && nr < 33.75) return 'NNE';
	if (nr >= 33.75 && nr < 56.25) return 'NE';
	if (nr >= 56.25 && nr < 78.75) return 'ENE';
	if (nr >= 78.75 && nr < 101.25) return 'E';
	if (nr >= 101.25 && nr < 123.75) return 'ESE';
	if (nr >= 123.75 && nr < 146.25) return 'SE';
	if (nr >= 146.25 && nr < 168.75) return 'SSE';
	if (nr >= 168.75 && nr < 191.25) return 'S';
	if (nr >= 191.25 && nr < 213.75) return 'SSW';
	if (nr >= 213.75 && nr < 236.25) return 'SW';
	if (nr >= 236.25 && nr < 258.75) return 'WSW';
	if (nr >= 258.75 && nr < 281.25) return 'W';
	if (nr >= 281.25 && nr < 303.75) return 'WNW';
	if (nr >= 303.75 && nr < 326.25) return 'NW';
	if (nr >= 326.25 && nr < 348.75) return 'NNW';
	return 'none';
}

function getFullDay_old(ziua)
{
	switch (ziua){
		case 'Sun':
			return 'Sunday';
			break;
		case 'Mon':
			return 'Monday';
			break;
		case 'Tue':
			return 'Tuesday';
			break;
		case 'Wed':
			return 'Wednesday';
			break;
		case 'Thu':
			return 'Thursday';
			break;
		case 'Fri':
			return 'Friday';
			break;
		case 'Sat':
			return 'Saturday';
			break;
		default:
			return 'Unknown';
			break;
	}
}

function getFullDay(ziua)
{
	switch (ziua){
		case 0:
			return 'Sunday';
			break;
		case 1:
			return 'Monday';
			break;
		case 2:
			return 'Tuesday';
			break;
		case 3:
			return 'Wednesday';
			break;
		case 4:
			return 'Thursday';
			break;
		case 5:
			return 'Friday';
			break;
		case 6:
			return 'Saturday';
			break;
		default:
			return 'Unknown';
			break;
	}
}

function displayFromCode(code)
{
	var ret;
	switch (code){
		case '600':
		case '601':
		case '602':
		case '611':
		case '612':
		case '615':
		case '616':
		case '620':
		case '621':
		case '622':
			//ret = chanceSnow.clone(false); 
			ret = new lib.snowy();
			ret.scaleX = ret.scaleY = iconScale;
			moveSnowy(ret);
			//return new ChanceSnow();
			return ret;
			break;
		case '200':
		case '201':
		case '202':
		case '210':
		case '211':
		case '212':
		case '221':
		case '230':
		case '231':
		case '232':
			//console.log('storm');
			//ret = chanceStorm.clone(false);
			ret = new lib.stormy();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 10 * iconScale;
			ret.regY = -20;
			//return new ChanceStorm();
			return ret;
			break;
		case '300':
		case '301':
		case '302':
		case '310':
		case '311':
		case '312':
		case '313':
		case '314':
		case '321':
			//console.log('cloud');
			//ret = chanceCloudy.clone(false);
			ret = new lib.clowdyz();
			sunY = ret.sun.y;
			norY = ret.nor2.y;
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 150// * iconScale;
			ret.regY = 61// * iconScale;
			moveClowdy(ret);
			//return new ChanceClouds();
			return ret;
			break;
		case '800':
			//ret = chanceClear.clone(false);
			ret = new lib.sunn();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 74 * 0.55;
			ret.regY = 61 * 0.55;
			ret.name = 'sunny';
			moveSunny(ret);
			//return new ChanceClear();
			return ret;
			break;
		default:
			//ret = chanceRain.clone(false);
			ret = new lib.rainy();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 100// * iconScale;
			ret.regY = 61 ;
			moveRainy(ret);
			//return new ChanceRain();
			return ret;
			break
	}
}

function displayFromCode__(code)
{
	var ret;
	switch (code){
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '13':
		case '14':
		case '15':
		case '16':
		case '17':
		case '18':
		case '41':
		case '42':
		case '43':
		case '46':
			//ret = chanceSnow.clone(false); 
			ret = new lib.snowy();
			ret.scaleX = ret.scaleY = iconScale;
			moveSnowy(ret);
			//return new ChanceSnow();
			return ret;
			break;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '37':
		case '38':
		case '39':
		case '45':
		case '47':
			//console.log('storm');
			//ret = chanceStorm.clone(false);
			ret = new lib.stormy();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 10 * iconScale;
			ret.regY = -20;
			//return new ChanceStorm();
			return ret;
			break;
		case '20':
		case '21':
		case '22':
		case '23':
		case '24':
		case '25':
		case '26':
		case '27':
		case '28':
		case '29':
		case '30':
			//console.log('cloud');
			//ret = chanceCloudy.clone(false);
			ret = new lib.clowdyz();
			sunY = ret.sun.y;
			norY = ret.nor2.y;
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 150// * iconScale;
			ret.regY = 61// * iconScale;
			moveClowdy(ret);
			//return new ChanceClouds();
			return ret;
			break;
		case '31':
		case '32':
		case '33':
		case '34':
		case '36':
			//ret = chanceClear.clone(false);
			ret = new lib.sunn();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 74 * 0.55;
			ret.regY = 61 * 0.55;
			ret.name = 'sunny';
			moveSunny(ret);
			//return new ChanceClear();
			return ret;
			break;
		default:
			//ret = chanceRain.clone(false);
			ret = new lib.rainy();
			ret.scaleX = ret.scaleY = iconScale;
			ret.regX = 100// * iconScale;
			ret.regY = 61 ;
			moveRainy(ret);
			//return new ChanceRain();
			return ret;
			break
	}
}

//day forecast object
(function() {
	var ChanceRain = function() {
		this.initialize();
	}
	var M = ChanceRain.prototype = new createjs.Container(); // inherit from Container
	M.Container_initialize = M.initialize;
	M.initialize = function() {
    	this.Container_initialize();
    	this.addChild(chanceRain);
	}
	window.ChanceRain = ChanceRain;
}(window));

(function() {
	var ChanceClear = function() {
		this.initialize();
	}
	var M = ChanceClear.prototype = new createjs.Container(); // inherit from Container
	M.Container_initialize = M.initialize;
	M.initialize = function() {
    	this.Container_initialize();
    	this.addChild(chanceClear);
	}
	window.ChanceClear = ChanceClear;
}(window));

(function() {

	var ChanceSnow = function() {
		this.initialize();
	}
	var M = ChanceSnow.prototype = new createjs.Container(); // inherit from Container
	M.Container_initialize = M.initialize;
	M.initialize = function() {
    	this.Container_initialize();
    	this.addChild(chanceSnow);
	}
	window.ChanceSnow = ChanceSnow;
}(window));

(function() {
	var ChanceStorm = function() {
		this.initialize();
	}
	var M = ChanceStorm.prototype = new createjs.Container(); // inherit from Container
	M.Container_initialize = M.initialize;
	M.initialize = function() {
    	this.Container_initialize();
    	this.addChild(chanceStorm);
	}
	window.ChanceStorm = ChanceStorm;
}(window));

(function() {
	var ChanceClouds = function() {
		this.initialize();
	}
	var M = ChanceClouds.prototype = new createjs.Container(); // inherit from Container
	M.Container_initialize = M.initialize;
	M.initialize = function() {
    	this.Container_initialize();
    	this.addChild(chanceCloudy);
	}
	window.ChanceClouds = ChanceClouds;
}(window));

function createDayWeather4(d, hi, lo, c, cond)
{
	console.log('d:',d,' hi:',hi,' lo:',lo,' c:',c,' cond:',cond);
	var daay = new lib.dayForecast4_1();

	daay.conditions.text = cond;
	daay.highTom.text = hi+'°';
	daay.lowTom.text = lo+'°';

	daay.conditions.y += 10;
	daay.conditions.x += 3;
	daay.highTom.y+= 10;
	daay.lowTom.y+=10;
	daay.whatDay.y+=5;

	daay.highTom.font = "bold 38px Montserrat";
	daay.lowTom.font = "bold 32px Montserrat";
	daay.conditions.font = "cond 14px Montserrat";

	daay.whatDay.text = d; 
	daay.whatDay.shadow = new createjs.Shadow("rgba(0,0,0,1)",0,0,7);

	daay.backItem.shape_2.shadow = new createjs.Shadow("rgba(0,0,0,1)", 0, 0, 20);

	var icon = displayFromCode(c);
	icon.x = 40;
	icon.y = 90;
	//console.log('icon: '+icon.id);
 	
 	daay.addChild(icon);

	return daay;
}

function createDayWeather1(d, hi, lo, c, cond)
{
	var daay = new lib.dayForecast();

	daay.conditions.text = cond;
	daay.highTom.text = hi+'°';
	daay.lowTom.text = lo+'°';

	daay.conditions.y += 10;
	daay.conditions.x += 3;
	daay.highTom.y+= 5;
	daay.lowTom.y+=5;
	daay.whatDay.y+=5;

	daay.highTom.font = "bold 20px Montserrat";
	daay.lowTom.font = "bold 20px Montserrat";
	daay.conditions.font = "bold cond 44px Montserrat";

	daay.whatDay.text = d;
	daay.whatDay.y += 3;
	daay.whatDay.shadow = new createjs.Shadow("rgba(0,0,0,1)",0,0,7);

	//console.log('backItem:',daay.instance_1);
	daay.instance_1.alpha = 0.25;
	daay.instance_1.shape.shadow = new createjs.Shadow("rgba(0,0,0,1)", 0, 0, 20);

	daay.instance_2.visible = false;

	var icon = displayFromCode(c);
	icon.x = 60;
	icon.y = 110;
	//console.log('icon: '+icon.id);
 	
 	daay.addChild(icon);

	return daay;
}

function createDayWeather2(d, hi, lo, c, cond)
{
	var daay = new lib.dayForecast2_1();

	daay.conditions.text = cond;
	daay.highTom.text = hi+'°';
	daay.lowTom.text = lo+'°';

	daay.conditions.y += 10;
	daay.conditions.x += 3;
	daay.highTom.y+= 5;
	daay.lowTom.y+=5;
	daay.whatDay.y+=8;

	daay.highTom.font = "bold 20px Montserrat";
	daay.lowTom.font = "bold 20px Montserrat";
	daay.conditions.font = "bold cond 14px Montserrat";

	daay.whatDay.text = d;
	daay.whatDay.shadow = new createjs.Shadow("rgba(0,0,0,1)",0,0,7);

	//console.log('backItem:',daay.instance_1);
	daay.instance_1.alpha = 0.25;
	//daay.instance.shape.shadow = new createjs.Shadow("rgba(0,0,0,1)", 0, 0, 20);

	//daay.instance_1.visible = false;

	var icon = displayFromCode(c);
	icon.x = 60;
	icon.y = 110;
	//console.log('icon: '+icon.id);
 	
 	daay.addChild(icon);

	return daay;
}

function createDayWeather3(d, hi, lo, c, cond)
{
	var daay = new lib.dayForecast3_1();

	daay.conditions.text = cond;
	daay.highTom.text = hi+'°';
	daay.lowTom.text = lo+'°';

	daay.conditions.y += 10;
	daay.conditions.x += 3;
	daay.highTom.y+= 5;
	daay.lowTom.y+=5;
	daay.whatDay.y+=8;

	daay.highTom.font = "bold 20px Montserrat";
	daay.lowTom.font = "bold 20px Montserrat";
	daay.conditions.font = "bold cond 14px Montserrat";

	daay.whatDay.text = d;
	daay.whatDay.shadow = new createjs.Shadow("rgba(0,0,0,1)",0,0,7);

	//console.log('backItem:',daay.instance_1);
	daay.instance.alpha = 0.65;
	//daay.instance.shape.shadow = new createjs.Shadow("rgba(0,0,0,1)", 0, 0, 20);

	//daay.instance_1.visible = false;

	var icon = displayFromCode(c);
	icon.x = 60;
	icon.y = 110;
	//console.log('icon: '+icon.id);
 	
 	daay.addChild(icon);

	return daay;
}

function createDayWeather1__(d,hi,lo,c)
{
	var cont = new createjs.Container();

	var graphicss = new createjs.Graphics().beginFill("#444444").drawRect(0, 0, 170, 115);
 	var bgShapee = new createjs.Shape(graphicss);
 	bgShapee.alpha = 0;

 	var dayTex = new createjs.Text(d, '18px Montserrat', '#BBBBBB');
 	dayTex.textAlign = 'center';
 	dayTex.y = 5;
 	dayTex.x = 85;

 	var hiText = new createjs.Text(hi+'°'+' high', 'bold 16px Arial', '#EEEEEE');
 	var loText = new createjs.Text(' low ' +lo+'°', 'bold 16px Arial', '#999999');
	hiText.y = 85;
	loText.y = 85;

	hiText.textAlign = 'left';
	loText.textAlign = 'right';
	hiText.x = 85 + 10;
	loText.x = 85 - 10;

	var icon = displayFromCode(c);
	icon.x = 85;
	icon.y = 55;
	//console.log('icon: '+icon.id);
 	cont.addChild(bgShapee);
 	cont.addChild(dayTex);
 	cont.addChild(loText);
 	cont.addChild(hiText);
 	cont.addChild(icon);
 	return cont;

}

function moveSunny(sun)
{
	var halou = sun.halou;
	var coroana = sun.coroana;

	if (halou.alpha >= 50)
	{
		createjs.Tween
			.get(halou)
			.wait(0)
			.to({scaleX:2, scaleY:2, alpha:0}, 2000, createjs.Ease.cubicOut);
		createjs.Tween
			.get(coroana)
			.wait(0)
			.to({rotation:coroana.rotation+60}, 2000, createjs.Ease.linear)
			.call(moveSunny, [sun]);
	}
	else
	{
		halou.scaleX = halou.scaleY = 1;
		halou.alpha = 0.5;
		createjs.Tween
			.get(halou)
			.wait(0)
			.to({scaleX:2, scaleY:2, alpha:0}, 2000, createjs.Ease.cubicOut);
		createjs.Tween
			.get(coroana)
			.wait(0)
			.to({rotation:coroana.rotation+60}, 2000, createjs.Ease.linear)
			.call(moveSunny, [sun]);
	}

}

var clow = true;

function moveClowdy(clowd)
{
	if (clow)
	{
		moveClowdy2(clowd)
		clow = false;
	}
	var son = clowd.sun;
	if (sunY == son.y)
	{
		createjs.Tween
			.get(son)
			.wait(0)
			.to({y:son.y + 14, alpha: 0.4}, 5000, createjs.Ease.cubicOut)
			.call(moveClowdy, [clowd]);
	}else{
		createjs.Tween
			.get(son)
			.wait(0)
			.to({y:sunY, alpha:1}, 4000, createjs.Ease.cubicOut)
			.call(moveClowdy, [clowd]);
	}
}

function moveClowdy2(clowd)
{
	var clowd2 = clowd.nor2;

	if (norY == clowd2.y)
	{
		createjs.Tween
			.get(clowd2)
			.wait(0)
			.to({y:clowd2.y - 28, alpha:0.4}, 5000, createjs.Ease.cubicOut)
			.call(moveClowdy2, [clowd])
	}else{
		createjs.Tween
			.get(clowd2)
			.wait(0)
			.to({y:norY, alpha:0.8}, 4000, createjs.Ease.cubicOut)
			.call(moveClowdy2, [clowd])
	}
}


function moveRainy(rain)
{
	var tempCont = rain.rainHolder;
	rainArr[rainCount] = [];
	for (var i=0;i<20;i++)
	{
		var drop = new lib.raind();
		drop.name = 'drop'+i;
		tempCont.addChild(drop);
		drop.x = Math.random()*140 + 50;
		drop.y = Math.random()*200 ;
		drop.scaleX = Math.random() * 0.7 + 0.4;
		drop.scaleY = drop.scaleX;
		drop.vx = drop.vy = 0;
		rainArr[rainCount].push(drop);
	}
	tempCont.rainArray = rainArr[rainCount];

	rainCount++;
}

function moveSnowy(snow)
{
	var temCont = snow.fulgHolder;
	snowArr[snowCount] = [];
	for (var i=0;i<15;i++)
	{
		var fulg = new lib.flake();
		fulg.name = 'fulg'+i;
		temCont.addChild(fulg);
		fulg.x = Math.random()*120 + 70;
		fulg.y = Math.random()*200;
		fulg.rotation = Math.random()*360;
		fulg.vx = fulg.vy = 0;

		snowArr[snowCount].push(fulg);		
	}

	temCont.snowArray = snowArr[snowCount];

	snowCount++;
}

function tick(event)
{

	for (var i = 0;i<rainArr.length; i++)
	{
		moveRain(rainArr[i]);
	}

	for (i=0; i<snowArr.length;i++)
	{
		moveSnow(snowArr[i])
	}
	stage.update();	
}

function moveRain(rainDropsArray)
{
	for (var i = 0;i<rainDropsArray.length; i++)
	{
		rainDropsArray[i].vy += (GRAVITY);
		rainDropsArray[i].vy *= FRICTION;

		var tmpNr = Math.random()*0.5 - 0.5;

		//console.log(rainDropsArray[i])

		rainDropsArray[i].vx += tmpNr;
		rainDropsArray[i].vx *= FRICTION;

		rainDropsArray[i].y += rainDropsArray[i].vy;
		rainDropsArray[i].x += rainDropsArray[i].vx;

		if (rainDropsArray[i].y > 120)
		{
			rainDropsArray[i].y = Math.random() * 50 - 25;
			rainDropsArray[i].x = Math.random() * 120 + 40;
			rainDropsArray[i].vx = rainDropsArray[i].vy = 0;
		}
	}
}

function moveSnow(flakesArray)
{
	for (var i=0;i<flakesArray.length;i++)
	{
		flakesArray[i].vy += (GRAVITY - 3);
		flakesArray[i].vy *= FRICTION;
		var tmpNr = Math.random()*4 -2;
		flakesArray[i].vx += tmpNr;		
		flakesArray[i].vx *= FRICTION;
		flakesArray[i].y += flakesArray[i].vy;
		flakesArray[i].x += flakesArray[i].vx;
		if (flakesArray[i].y>120)
		{
			flakesArray[i].x = Math.random() * 120 + 40;
			flakesArray[i].y = Math.random() * 50;
			flakesArray[i].vx = flakesArray[i].vy = 0;
		}
	}
}